## ecl 16.1.2

=== msvc/Makefile ===
#
#		Makefile for ECoLisp
#
top_srcdir= ..\src
srcdir	= ..\src

# =============================================================
# ECL configuration
# <BEGIN>

SHORT_SITE_NAME   =
LONG_SITE_NAME    =
ECL_VERSION       = 16.1.2
ECL_VERSION_NUMBER= 161002
ARCHITECTURE      = PENTIUM4
SOFTWARE_TYPE     = NT
SOFTWARE_VERSION  = 5.0
THEHOST           = win32

# Define to 1 to make a 64-bit build
# ECL_WIN64 =

# Define here the processor type to compile GMP library
# with maximum optimization. Possible values are:
# 	gc -> generic implementation
# 	p0 -> Pentium processor
# 	p3 -> Pentium III processor
# 	p4 -> Pentium IV processor
!if "$(GMP_TYPE)" == ""
GMP_TYPE = gc
!endif

# Set it to non-empty to include Win32 thread support
# Currently it is NOT SUPPORTED to build ECL without threads. The reason
# is that certain exception handlers in Windows always use new threads.
# Without them, ECL would be an even more fragile piece of software.
ECL_THREADS   = 1

# Set it to empty to remove support for Unicode characters
ECL_UNICODE = 1

# Set it to non-empty to enable Win32 debug support
#ECL_DEBUG = 1

# Set it to non-empty to support SSE2 intrinsics
ECL_SSE =

# Add the extensions to include in the build process. Comment any
# of the following lines to remove a feature from the build process
# LISP->C compiled
ECL_CMP     =
# ASDF support
ECL_ASDF    =
# TCP support
ECL_SOCKETS =
# X Windows support
# ECL_CLX     = 1
# Regression Tests support
ECL_RT      =
# Defsystem support
ECL_DEFSYS  =
# Profiling
ECL_PROFILE =

# <END> (ECL configuration)
# =============================================================

TAR_DIR = %CD%\ecl-$(ECL_VERSION)

# Programs used by "make":
#

CC	= cl
LIBS	= eclgc.lib eclgmp.lib user32.lib ws2_32.lib shell32.lib
RM	= del
RMDIR   = rmdir /Q /S
MKDIR   = mkdir
EXE	= .exe
CP      = copy /Y
MV      = move /Y
MSDEV   = msdev
MKNSI   = makensis.exe

!if "$(YASM)" == ""
YASM=yasm-1.2.0-win32.exe
!endif

# ==================== Flags ====================

!if "$(ECL_WIN64)" != ""
GMP_BITS=64
GC_CPU=AMD64
ARCHITECTURE=AMD64
VCREDIST=vcredist_x64.exe
!else
GMP_BITS=32
GC_CPU=i386
ARCHITECTURE=PENTIUM4
VCREDIST=vcredist_x86.exe
!if "$(ECL_SSE)" != ""
CFLAGS_SSE=/arch:SSE2
!endif
!endif

#
# Configuration-specific (Debug/Release) options
#
!if "$(ECL_DEBUG)" != ""
CFLAGS_OPTIMIZE = /Od
CFLAGS_CONFIG = /Zi /D_DEBUG /MDd $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = /debug /nodefaultlib:msvcrt.lib
SHARED_LDFLAGS = /LDd
GCFLAGS =
!else
CFLAGS_OPTIMIZE = /O2
CFLAGS_CONFIG = /DNDEBUG /MD $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = /nodefaultlib:msvcrtd.lib
SHARED_LDFLAGS = /LD
GCFLAGS = nodebug=1
!endif

CFLAGS  = /EHsc /DGC_DLL /DGC_BUILD /nologo /D_CRT_SECURE_NO_DEPRECATE $(CFLAGS_CONFIG)
LDFLAGS	= /link /incremental:no /nologo /nodefaultlib:libcmt /nodefaultlib:libcmtd /nodefaultlib:libc /nodefaultlib:libcd $(LDFLAGS_CONFIG)


# Additional configuration for thread support
#
!if "$(ECL_THREADS)" == ""
ENV_EXPORT = cl_env,DATA
!else
ENV_EXPORT = ecl_process_env
CFLAGS     = $(CFLAGS)
DEF        = ecl-threads.def
!endif

!MESSAGE C++ compiler flags: $(CFLAGS)
!MESSAGE C++ linker flags: $(LDFLAGS)

# ==================== Where To Install Things ====================

# The default location for installation.  Everything is placed in
# subdirectories of this directory.  The default values for many of
# the variables below are expressed in terms of this one, so you may
# not need to change them.  This defaults to /usr/local.
prefix=%CD%\package
exec_prefix=$(prefix)
bindir=$(prefix)
libdir=$(prefix)
includedir=$(prefix)
docdir=$(prefix)\doc

# Programs used by "make install":
#
SHELL = @SHELL@
INSTALL	= @INSTALL@
INSTALL_PROGRAM = @INSTALL_PROGRAM@
INSTALL_SCRIPT = @INSTALL_SCRIPT@
INSTALL_DATA = @INSTALL_DATA@
mkinstalldirs = $(top_srcdir)/bdwgc/install-sh -d

# Files
#
SUBDIR        = c gc gmp
LIBRARIES     =
TARGETS       = ecl2$(EXE)
DEF           = ecl.def

# Additional modules
# 
ECL_MODULES  =
ECL_FEATURES = (cons :wants-dlopen *features*)
!ifdef ECL_CMP
ECL_MODULES  = $(ECL_MODULES) cmp
ECL_FEATURES = (cons :wants-cmp $(ECL_FEATURES))
!endif
!ifdef ECL_ASDF
ECL_MODULES  = $(ECL_MODULES) asdf
ECL_FEATURES = (cons :wants-asdf $(ECL_FEATURES))
!endif
!ifdef ECL_SOCKETS
ECL_MODULES  = $(ECL_MODULES) sockets
ECL_FEATURES = (cons :wants-sockets $(ECL_FEATURES))
!endif
!ifdef ECL_CLX
ECL_MODULES  = $(ECL_MODULES) clx
ECL_FEATURES = (cons :wants-clx $(ECL_FEATURES))
!endif
!ifdef ECL_RT
ECL_MODULES  = $(ECL_MODULES) rt
ECL_FEATURES = (cons :wants-rt $(ECL_FEATURES))
!endif
!ifdef ECL_DEFSYS
ECL_MODULES  = $(ECL_MODULES) defsystem
ECL_FEATURES = (cons :wants-defsystem $(ECL_FEATURES))
!endif
!ifdef ECL_PROFILE
ECL_MODULES  = $(ECL_MODULES) profile
ECL_FEATURES = (cons :wants-profile $(ECL_FEATURES))
!endif
ECL_MODULES  = $(ECL_MODULES) bytecmp
ECL_FEATURES = (list* :builtin-bytecmp :wants-bytecmp $(ECL_FEATURES))
ECL_MODULES  = $(ECL_MODULES) ecl-curl
ECL_FEATURES = (cons :wants-ecl-curl $(ECL_FEATURES))
ECL_MODULES  = $(ECL_MODULES) deflate
ECL_FEATURES = (cons :wants-deflate $(ECL_FEATURES))

!MESSAGE ECL Modules: $(ECL_MODULES)
!MESSAGE ECL Features: $(ECL_FEATURES)

# Build rules
# 
all:	$(TARGETS) ecl-config.bat ecl-cc.bat
.PHONY:	all

%Makefile: $(srcdir)/%Makefile.in config.status
	./config.status

c\cut$(EXE): $(top_srcdir)\util\cut.c
	cd c
	$(MAKE) cut$(EXE)
	cd ..

$(TARGETS): $(UCDDAT) ecl_min$(EXE) compile.lsp sysfun.lsp BUILD-STAMP
	set ECLDIR=./
	ecl_min < compile.lsp
BUILD-STAMP: Makefile
	date /t > $@

ecl-static.lib: $(TARGETS)
	link /lib /out:$@ eclmin.lib c\all_symbols2.obj lsp.lib eclgmp.lib eclgc.lib

ecl_min$(EXE): $(LIBRARIES) eclmin.lib
	$(CC) /Fe$@ cinit.obj c\all_symbols.obj eclmin.lib $(LDFLAGS) $(LIBS)
	if exist ecl_min$(EXE).manifest \
	 mt -manifest ecl_min.exe.manifest -outputresource:ecl_min.exe;1
	-$(RM) ecl_min.exp ecl_min.lib ecl_min$(EXE).manifest

.gdbinit: $(srcdir)\util\gdbinit
	$(CP) $(srcdir)\util\gdbinit $@

lsp/config.lsp: $(srcdir)/lsp/config.lsp.in Makefile c\cut$(EXE)
	if not exist lsp $(MKDIR) lsp
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@SHORT_SITE_NAME@" "$(SHORT_SITE_NAME)" \
	    "@LONG_SITE_NAME@" "$(LONG_SITE_NAME)" \
	    "@PACKAGE_VERSION@" "$(ECL_VERSION)" \
	    "@ARCHITECTURE@" "$(ARCHITECTURE)" \
	    "@SOFTWARE_TYPE@" "$(SOFTWARE_TYPE)" \
	    "@SOFTWARE_VERSION@" "$(SOFTWARE_VERSION)" \
	    "@thehost@" "$(THEHOST)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@top_srcdir@" "$(top_srcdir:\=/)/" \
	    < $(srcdir)\lsp\config.lsp.in > lsp\config.lsp
compile.lsp: bare.lsp $(srcdir)/compile.lsp.in Makefile
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@libdir\@" "$(libdir:\=/)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)" \
	    "@CFLAGS@" "$(CFLAGS) -DGC_BUILD" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@STATICLIBS@" "eclgmp.lib eclgc.lib" \
	    "@LIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@CORE_LIBS@" "" \
	    "@FASL_LIBS@" "" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "lib" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@LDINSTALLNAME@" "" \
	    "@DEF@" "$(DEF)" \
            "@RANLIB@" "ranlib" \
	    "@LSP_FEATURES@" "$(ECL_FEATURES)" \
	    "@ECL_CMPDIR@" "cmp" \
	    "@ECL_EXTRA_LISP_FILES@" "" \
	    "@ECL_INIT_FORM@" "(si::top-level t)" \
	    < $(srcdir)\compile.lsp.in > compile.lsp
bare.lsp: $(srcdir)/bare.lsp.in lsp/load.lsp clos/load.lsp cmp/load.lsp cmp/cmpdefs.lsp
	c\cut "@true_srcdir@" "$(srcdir:\=/)" \
	    "@top_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)"\
	    "@ECL_CMPDIR@" "cmp" < $(srcdir)\bare.lsp.in > bare.lsp
lsp/load.lsp: $(srcdir)/lsp/load.lsp.in
	$(CP) $(srcdir)\lsp\load.lsp.in lsp\load.lsp
clos/load.lsp: $(srcdir)/clos/load.lsp.in
	if not exist clos $(MKDIR) clos
	$(CP) $(srcdir)\clos\load.lsp.in clos\load.lsp
cmp/load.lsp: $(srcdir)/cmp/load.lsp.in
	if not exist cmp $(MKDIR) cmp
	$(CP) $(srcdir)\cmp\load.lsp.in cmp\load.lsp
cmp/cmpdefs.lsp: $(srcdir)/cmp/cmpdefs.lsp Makefile
	c\cut "@ECL_CC@" "$(CC)" \
	    "@CC_IS_CXX@" "nil" \
	    "@CFLAGS@" "$(CFLAGS)" \
	    "@CFLAGS_OPTIMIZE@" "$(CFLAGS_OPTIMIZE)" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@STATICLIBS@" "eclgmp.lib eclgc.lib" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "dll" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@ecldir\@" "NIL" \
	    "@libdir\@" "NIL" \
	    "@includedir\@" "NIL" \
	    < $(srcdir)\cmp\cmpdefs.lsp > cmp\cmpdefs.lsp
ecl-config.bat: util\ecl-config.bat Makefile
	c\cut "~A" "$(libdir:\=/)"\
	    "~*" "" \
	    "@ECL_CFLAGS@" "$(CFLAGS)" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@CLIBS@" "" \
	    "@libdir@" "$(prefix:\=/)" \
	    "@includedir@" "$(prefix:\=/)/ecl" \
	    < util\ecl-config.bat > ecl-config.bat
ecl-cc.bat: util\ecl-cc.bat Makefile
	c\cut "@ECL_CFLAGS@" "$(CFLAGS)" \
	      "@LDFLAGS@" "$(LDFLAGS)" \
	      "@CLIBS@" "" \
	      "@libdir@" "$(prefix:\=/)" \
	      "@includedir@" "$(prefix:\=/)/ecl" \
	      < util\ecl-cc.bat > ecl-cc.bat


eclmin.lib: eclgmp.lib eclgc.lib lsp/config.lsp
	cd c
	$(MAKE) ECL_VERSION_NUMBER=$(ECL_VERSION_NUMBER) \
	        ECL_THREADS=$(ECL_THREADS) ECL_UNICODE=$(ECL_UNICODE) \
		ECL_SSE=$(ECL_SSE) ECL_WIN64=$(ECL_WIN64) \
		"ECL_CFLAGS=$(CFLAGS) -DGC_BUILD"
	cd ..
eclgc.lib:
	cd gc
	$(MAKE) $(GCFLAGS) ECL_THREADS=$(ECL_THREADS) "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" "MY_CPU=$(GC_CPU)" gc.lib
	$(CP) gc.lib ..\eclgc.lib
	cd ..
	if not exist ecl\gc $(MKDIR) ecl\gc
	if not exist ecl\gc\private $(MKDIR) ecl\gc\private
	for %h in (gc.h gc_version.h gc_local_alloc.h gc_pthread_redirects.h \
	           gc_config_macros.h leak_detector.h gc_typed.h \
	           private\gc_priv.h private\gcconfig.h gc_mark.h \
		   new_gc_alloc.h weakpointer.h gc_pthread_redirects.h) \
	    do $(CP) $(srcdir)\bdwgc\include\%h ecl\gc\%h

eclgmp.lib:
	cd gmp
	$(MAKE) "MPN_TYPE=$(GMP_TYPE)" "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" \
		"BITS=$(GMP_BITS)" "YASM=$(YASM)"
	$(CP) gmp.lib ..\eclgmp.lib
	$(CP) gmp.h ..\ecl\gmp.h
	cd ..
sysfun.lsp:
	$(CP) $(srcdir)\cmp\sysfun.lsp .\

rt.lisp:
	$(CP) $(srcdir)\..\contrib\rt\rt.lisp .\

install:
	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
	IF NOT EXIST "$(bindir)" $(MKDIR) "$(bindir)"
	for %i in ($(TARGETS) ecl.dll) do $(CP) %i "$(bindir)\%i"
	IF EXIST "$(bindir)\ecl2$(EXE)" $(MV) "$(bindir)\ecl2$(EXE)" "$(bindir)\ecl$(EXE)"
	IF EXIST ecl2$(EXE).manifest $(CP) ecl2$(EXE).manifest "$(bindir)\ecl$(EXE).manifest"
	IF EXIST ecl.dll.manifest $(CP) ecl.dll.manifest "$(bindir)"
	$(CP) ecl-config.bat "$(bindir)\ecl-config.bat"
	$(CP) ecl-cc.bat "$(bindir)\ecl-cc.bat"
	IF NOT EXIST "$(includedir)\ecl" $(MKDIR) "$(includedir)\ecl"
	IF NOT EXIST "$(includedir)\ecl\gc" $(MKDIR) $(includedir)\ecl\gc
	IF NOT EXIST "$(includedir)\ecl\gc\private" $(MKDIR) "$(includedir)\ecl\gc\private"
	for %i in (ecl\*.h ecl\gc\*.h ecl\gc\private\*.h) do $(CP) %i $(includedir)\%i
	IF EXIST "$(include)\ecl\atomic_ops" rmdir /S /Q "$(include)\ecl\atomic_ops"
	IF EXIST "ecl\atomic_ops" xcopy /S /Y "ecl\atomic_ops" "$(includedir)\atomic_ops\"
	cd c
	$(MAKE) cut.exe
	cd ..
	c\cut.exe < ecl\config.h > $(includedir)\ecl\config.h
	IF NOT EXIST "$(libdir)" $(MKDIR) "$(libdir)"
	IF NOT EXIST "$(libdir)\ecl" $(MKDIR) "$(libdir)\ecl"
	for %i in ($(LIBRARIES) c\dpp.exe BUILD-STAMP help.doc ecl.lib) do $(CP) %i "$(libdir)"
	for /f %i in ('type MODULES') do $(CP) %i "$(libdir)"
	for %i in (ecl-static.lib) do IF EXIST %i $(CP) %i "$(libdir)"

=== examples/embed/Makefile ===
hello.exe: hello.c hello-lisp.a
	$(CC) `ecl-config --cflags` -o $@ hello.c hello-lisp.a \
	      `ecl-config --ldflags` -lecl

hello-lisp.a: hello-lisp.lisp
	ecl -norc \
	    -eval '(require :asdf)' \
	    -eval '(push "./" asdf:*central-registry*)' \
	    -eval '(asdf:make-build :hello-lisp :type :static-library :move-here "./")' \
	    -eval '(quit)'

clean:
	-rm -f hello-lisp.a hello.exe

=== msvc/c/Makefile ===
#
#			Makefile for ECL core library
#
top_srcdir = ..\..\src
srcdir	= ..\..\src\c

!if "$(ECL_WIN64)" != ""
ECL_FFI_OBJ=
ECL_FPE_CODE=fpe_none.c
!else
ECL_FFI_OBJ=ffi_x86.obj
ECL_FPE_CODE=fpe_x86.c
!endif

!if "$(ECL_THREADS)" != ""
ECL_THREADS_FLAG=1
THREADS_OBJ= process.obj mutex.obj condition_variable.obj rwlock.obj \
             semaphore.obj barrier.obj mailbox.obj atomic.obj queue.obj
!else
ECL_THREADS_FLAG=0
THREADS_OBJ=
!endif

!if "$(ECL_UNICODE)" != ""
ECL_UNICODE_FLAG=21
ECL_UCD_OBJ = ucd.obj ucd-0000.obj ucd-0016.obj \
	      ucd-0032.obj ucd-0048.obj ucd-0064.obj \
	      ucd-0080.obj ucd-0096.obj
!else
ECL_UNICODE_FLAG=0
!endif

!if "$(ECL_SSE)" != ""
ECL_SSE_FLAG=1
ECL_SSE_OBJ=sse2.obj
!else
ECL_SSE_FLAG=0
ECL_SSE_OBJ=
!endif

# Programs used by "make":
#
TRUE_CC = cl
CC	= cl
CFLAGS	= -c $(ECL_CFLAGS) -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/bdwgc/include  -I$(top_srcdir)/bdwgc/include/private

SHELL	= /bin/sh
RM	= del
CP      = copy /Y
MV      = move /Y
LINK    = link
EXE	= .exe
DPP	= .\dpp$(EXE)

# Data for installation
#
INSTALL = @INSTALL@
INSTALL_DATA = @INSTALL_DATA@
prefix=@prefix@
exec_prefix=$(prefix)
libdir=$(prefix)\lib\ecl

# Files

HDIR	= $(top_srcdir)\h
HFILES	= ..\ecl\config.h ..\ecl\atomic_ops.h $(HDIR)\ecl.h $(HDIR)\ecl-cmp.h\
	$(HDIR)\object.h $(HDIR)\cs.h $(HDIR)\stacks.h\
	$(HDIR)\external.h $(HDIR)\cons.h $(HDIR)\legacy.h\
	$(HDIR)\number.h $(HDIR)\page.h $(HDIR)\unify.h\
	$(HDIR)\internal.h $(HDIR)\ecl-inl.h $(HDIR)\bytecodes.h \
	$(HDIR)\impl\math_dispatch.h

OBJS	= main.obj symbol.obj package.obj cons.obj list.obj\
	apply.obj eval.obj \
	interpreter.obj compiler.obj disassembler.obj \
	instance.obj gfun.obj cache.obj accessor.obj \
	reference.obj character.obj\
	file.obj read.obj print.obj error.obj string.obj cfun.obj\
	parse_integer.obj parse_number.obj \
	float_to_digits.obj float_to_string.obj \
	integer_to_string.obj write_ugly.obj \
	write_object.obj write_symbol.obj \
	write_array.obj write_list.obj write_code.obj \
	write_sse.obj print_unreadable.obj \
	libraries.obj backtrace.obj mmap.obj cdata.obj \
	cos.obj sin.obj tan.obj atan.obj \
	cosh.obj sinh.obj tanh.obj \
	exp.obj expt.obj log.obj \
	sqrt.obj abs.obj \
	zerop.obj plusp.obj minusp.obj \
	negate.obj conjugate.obj \
	one_plus.obj one_minus.obj \
	plus.obj minus.obj times.obj divide.obj \
	number_compare.obj number_equalp.obj minmax.obj \
	floor.obj ceiling.obj round.obj truncate.obj \
	typespec.obj assignment.obj \
	predicate.obj big.obj number.obj\
	num_pred.obj num_arith.obj num_co.obj\
	num_log.obj num_rand.obj array.obj vector_push.obj \
	sequence.obj cmpaux.obj\
	macros.obj backq.obj stacks.obj \
	time.obj unixint.obj\
	mapfun.obj multival.obj hash.obj format.obj pathname.obj\
	structure.obj load.obj unixfsys.obj unixsys.obj \
	ffi.obj alloc_2.obj tcp.obj $(THREADS_OBJ) serialize.obj \
	$(ECL_FFI_OBJ) $(ECL_UCD_OBJ) $(ECL_SSE_OBJ)

all:	$(DPP) ..\eclmin.lib ..\cinit.obj

.SUFFIXES: .obj .c .d

{$(srcdir:\=/)}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/arch}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/clos/}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/reader}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/printer}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/ffi}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/unicode}.c{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/numbers}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/threads}.d{}.c:
	$(DPP) $< $@

#.d.c:
#	$(DPP) $< $@
.c.obj:
	$(CC) $(CFLAGS) /Fo$@ $<

.PHONY:	all

cut.exe: $(top_srcdir)/util/cut.c
	$(CC) $(LDFLAGS) /Fecut.exe $(top_srcdir)/util/cut.c

..\eclmin.lib: $(OBJS:.obj=.c) all_symbols.c $(OBJS) all_symbols.obj all_symbols2.obj
	-$(RM) $@
	$(LINK) -lib -out:$@ $(OBJS)

clean:
	-for %f in ($(OBJS:.obj=.c) all_symbols.c) do $(RM) %f
	-for %f in ($(OBJS) all_symbols.obj all_symbols2.obj) do $(RM) %f
	-$(RM) *.pdb
	-for %f in (..\ecl\config.h dpp dpp.obj $(DPP) cut.exe cut.obj \
	            ..\eclmin.lib ..\cinit.obj cinit.c symbols_list2.h) \
	     do $(RM) %f
	-for %f in (..\ecl\*.h) do $(RM) %f
	-for %f in (cut.exe cut.obj dpp.exe dpp.obj) do $(RM) %f
	-del /S /Q ..\ecl\atomic*

# Build rules

$(DPP): $(srcdir)/dpp.c $(srcdir)/symbols_list2.h ../ecl/config.h
	$(TRUE_CC) -I.. -I./ $(srcdir)/dpp.c  -o $@
$(HFILES): ../ecl/config.h.msvc6 Makefile
	-mkdir ..\ecl\impl
	cut.exe "@ECL_FPE_CODE@" "$(srcdir:\=/)/arch/$(ECL_FPE_CODE)" \
		"@ECL_VERSION_NUMBER@" "$(ECL_VERSION_NUMBER)" \
		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
	        < ..\ecl\config.h.msvc6 > $@
	xcopy /SYI $(top_srcdir)\h\* ..\ecl
	-mkdir ..\ecl\atomic_ops
	-mkdir ..\ecl\atomic_ops\sysdeps
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops.h ..\ecl
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\generalize*.h ..\ecl\atomic_ops
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\sysdeps\* ..\ecl\atomic_ops\sysdeps
	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops\ao_version.h ..\ecl\atomic_ops

#
# GCC might break this code
#
gbc.o: gbc.c $(HFILES)
	$(CC) $(CFLAGS) -O0 gbc.c /Fo$@
#
# This reduces the overhead of jumping to other functions
#
apply.o: apply.c $(HFILES) $(HDIR)/cs.h
	$(CC) $(CFLAGS) apply.c /Fo$@
#
# These files are interrelated
#
all_symbols.obj: all_symbols.c
	$(CC) $(CFLAGS) -Fo$@ -I../ -I./ all_symbols.c
all_symbols2.obj: all_symbols.c
	$(CC) $(CFLAGS) -DECL_FINAL -Fo$@ -I../ -I./ all_symbols.c
#
# This is in another directory
#
../cinit.obj: cinit.c
	$(CC) $(CFLAGS) -I../ -I./ /Focinit.obj cinit.c
	$(MV) cinit.obj ..\

=== msvc/doc/Makefile ===
top_srcdir= ..\..\src
srcdir	= ..\..\src\doc

prefix=@prefix@
exec_prefix=$(prefix)\bin
infodir = $(prefix)\doc\info
mandir=$(prefix)\doc\man
docdir=$(prefix)\doc
manext=1

INFOEXT = info
SHELL = cmd.exe
INSTALL	= ..\install.bat
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA = $(INSTALL)
INSTALL_INFO = $(INSTALL)
mkinstalldirs = $(SHELL) $(top_srcdir)/gc/mkinstalldirs.bat
INFO_FILES = ecl.$(INFOEXT) ecldev.$(INFOEXT)
HTML_FILES = index.html license.html lgpl.html news.html benchmark.html \
	install.html download.html

RM     = erase
RMDIR  = rmdir /S /Q
MKDIR  = mkdir
CP     = copy /Y

ECL_VERSION=0.9f

FILTER = ..\c\cut$(EXE) "@PACKAGE_VERSION@" "$(ECL_VERSION)"

ECL = ../ecl

all: $(INFO_FILES) $(HTML_FILES) developers_manual user_manual clx_manual

ecl.dvi: $(srcdir)/user.txi $(srcdir)/macros.txi clisp.sty ecl.sty
	tex $(srcdir)/user.txi
ecldev.dvi: $(srcdir)/devel.txi $(srcdir)/macros.txi clisp.sty ecl.sty
	tex $(srcdir)/devel.txi
clx.dvi: clx.texinfo
	tex clx.texinfo

ecl.ps: ecl.dvi $(srcdir)/macros.txi
	dvips -o $@ ecl.dvi
ecldev.ps: ecldev.dvi $(srcdir)/macros.txi
	dvips -o $@ ecldev.dvi
clx.ps: clx.dvi
	dvips -o $@ clx.dvi

install: all
	IF NOT EXIST $(docdir) $(MKDIR) $(docdir)
	for %i in (Copyright LGPL) do $(CP) $(top_srcdir)\..\%i $(docdir)
	for %i in ($(HTML_FILES)) do $(CP) %i $(docdir)
	IF NOT EXIST $(docdir)\ecldev $(MKDIR) $(docdir)\ecldev
	for %i in (ecldev\*) do $(CP) %i $(docdir)\ecldev
	IF NOT EXIST $(docdir)\ecl $(MKDIR) $(docdir)\ecl
	for %i in (ecl\*) do $(CP) %i $(docdir)\ecl
	IF NOT EXIST $(docdir)\clx $(MKDIR) $(docdir)\clx
	for %i in (clx\*) do $(CP) %i $(docdir)\clx
flatinstall: all
	IF NOT EXIST $(docdir) $(MKDIR) $(docdir)
	for %i in (Copyright LGPL) do $(CP) $(top_srcdir)\..\%i $(docdir)
	for %i in ($(HTML_FILES)) do $(CP) %i $(docdir)
	IF NOT EXIST $(docdir)\ecldev $(MKDIR) $(docdir)\ecldev
	for %i in (ecldev\*) do $(CP) %i $(docdir)\ecldev
	IF NOT EXIST $(docdir)\ecl $(MKDIR) $(docdir)\ecl
	for %i in (ecl\*) do $(CP) %i $(docdir)\ecl
	IF NOT EXIST $(docdir)\clx $(MKDIR) $(docdir)\clx
	for %i in (clx\*) do $(CP) %i $(docdir)\clx

uninstall:
	for k in $(INFO_FILES); do \
	  rm $$k; \
	  if [ -x $(INSTALL_INFO) ]; then \
	    $(INSTALL_INFO) --delete $$k; \
	  fi; \
	done
	rm -r $(infodir)/ecl.$(INFOEXT) $(infodir)/ecldev.$(INFOEXT); \
	rm $(mandir)/man$(manext)/ecl.$(manext)

head2: developers_manual user_manual clx_manual $(srcdir)/head Makefile
	IF EXIST ecl\index.html ( \
	  ..\c\cut.exe "ecl/user.html" "ecl/index.html" \
	      "ecldev/devel.html" "ecldev/index.html" \
	      < $(srcdir)/head > head2 \
	) ELSE ( \
	  copy /y $(srcdir)/head head2 \
	)
ecl.info.gz: ecl.info
	gzip < ecl.info > ecl.info.gz
ecldev.info.gz: ecldev.info
	gzip < ecldev.info > ecldev.info.gz
clx.info.gz: clx.info
	gzip < clx.info > clx.info.gz
ecl.info: $(srcdir)/user.txi $(srcdir)/macros.txi
	makeinfo -I $(srcdir) --no-split $(srcdir)/user.txi
ecldev.info: $(srcdir)/devel.txi $(srcdir)/macros.txi
	makeinfo -I $(srcdir) --no-split $(srcdir)/devel.txi
clx.info: clx.texinfo
	makeinfo --no-split clx.texinfo
clx.texinfo: $(top_srcdir)/clx/manual/clx.texinfo
	cp $(top_srcdir)/clx/manual/clx.texinfo .

download.html: $(srcdir)/download.in.html head2
	( type head2 $(srcdir)\download.in.html $(srcdir)\end ) | $(FILTER) > $@
index.html: $(srcdir)/index.in.html head2
	( type head2 $(srcdir)\index.in.html $(srcdir)\end ) | $(FILTER) > $@
install.html: $(srcdir)/install.in.html head2
	( type head2 $(srcdir)\install.in.html $(srcdir)\end ) | $(FILTER) > $@
news.html: $(srcdir)\..\..\ANNOUNCEMENT head2
	type head2 > html_tmp
	echo "<pre>" >> html_tmp
	type $(srcdir)\..\..\ANNOUNCEMENT >> html_tmp
	echo "</pre>" >> html_tmp
	type $(srcdir)\end >> html_tmp
	$(FILTER) < html_tmp > $@
	$(RM) html_tmp
benchmark.html: $(srcdir)/benchmark.in.html ../gabriel/BENCHMARK head2
	type head2 > html_tmp
	type $(srcdir)\benchmark.in.html >> html_tmp
	echo "<pre>" >> html_tmp
	type ..\gabriel\BENCHMARK >> html_tmp
	echo "</pre>" >> html_tmp
	type $(srcdir)\end >> html_tmp
	$(FILTER) < html_tmp > $@
	$(RM) html_tmp
../gabriel/BENCHMARK:
	if not exist ..\gabriel $(MKDIR) ..\gabriel
	echo No benchmarks available > ..\gabriel\BENCHMARK
license.html: $(top_srcdir)/../Copyright head2
	type head2 > html_tmp
	echo "<pre>" >> html_tmp
	type $(top_srcdir)\..\Copyright >> html_tmp
	echo "</pre>" >> html_tmp
	type $(srcdir)\end >> html_tmp
	$(FILTER) < html_tmp > $@
	$(RM) html_tmp
lgpl.html: $(top_srcdir)/../LGPL head2
	type head2 > html_tmp
	echo "<pre>" >> html_tmp
	type $(top_srcdir)\..\LGPL >> html_tmp
	echo "</pre>" >> html_tmp
	type $(srcdir)\end >> html_tmp
	$(FILTER) < html_tmp > $@
	$(RM) html_tmp
user_manual: $(srcdir)/user.txi $(srcdir)/macros.txi
	echo "Producing ecl.html; ignore error messages."
	IF NOT EXIST ecl MKDIR ecl
	makeinfo -v -I $(srcdir) --html $(srcdir)/user.txi
	echo > user_manual
developers_manual: $(srcdir)/devel.txi $(srcdir)/macros.txi
	echo "Producing ecldev.html; ignore error messages."
	IF NOT EXIST ecldev MKDIR ecldev
	makeinfo -v -I $(srcdir) --html $(srcdir)/devel.txi
	echo > developers_manual
clx_manual: $(srcdir)/../clx/manual/clx.texinfo
	echo "Producing clx.html; ignore error messages."
	IF NOT EXIST clx MKDIR clx
	makeinfo -v --html $(srcdir)\..\clx\manual\clx.texinfo
	echo > clx_manual
clean:
	-for %i in (ecl ecldev clx ..\gabriel) do $(RMDIR) %i
	-for %i in (ecl.info* ecldev.info* $(HTML_FILES) head2 user_manual developers_manual clx_manual ..\gabriel\BENCHMARK) do $(RM) %i

=== msvc/gc/Makefile ===
# Makefile for Windows NT.  Assumes Microsoft compiler.
# DLLs are included in the root set under NT, but not under win32S.
# Use "nmake nodebug=1 all" for optimized versions of library, gctest and editor.
# MY_CPU=i386 for 32 bits or AMD64 for 64 bits
CPU=$(MY_CPU)
#!include <ntwin32.mak>

srcdir=..\..\src\bdwgc

!if "$(ECL_THREADS)" != ""
THREADS_OBJ= win32_threads.obj thread_local_alloc.obj
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DGC_WIN32_THREADS -DTHREAD_LOCAL_ALLOC -DLARGE_CONFIG
!else
THREADS_OBJ=
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DLARGE_CONFIG
!endif

# Make sure that .cc is not viewed as a suffix.  It is for VC++2005, but
# not earlier versions.  We can deal with either, but not inconsistency.
.SUFFIXES:
.SUFFIXES: .obj .cpp .c

# Atomic_ops installation directory.  For win32, the source directory
# should do, since we only need the headers.
# We assume this was manually unpacked, since I'm not sure there is
# a Windows standard command line tool to do this.
AO_SRC_DIR=$(srcdir)/libatomic_ops/src
AO_INCLUDE_DIR=$(AO_SRC_DIR)

OBJS= alloc.obj reclaim.obj allchblk.obj misc.obj mach_dep.obj os_dep.obj mark_rts.obj headers.obj mark.obj obj_map.obj blacklst.obj finalize.obj new_hblk.obj dbg_mlc.obj fnlz_mlc.obj malloc.obj stubborn.obj dyn_load.obj typd_mlc.obj ptr_chck.obj gc_cpp.obj mallocx.obj win32_threads.obj msvc_dbg.obj thread_local_alloc.obj

all: gc.lib

{$(srcdir)\extra}.c{}.obj:
	$(CC) -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)}.c{}.obj:
	$(CC) -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)}.cpp{}.obj:
	$(CC) -c -DWIN32 -D_MT $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

gc.lib: $(OBJS)
!if "$(CPU)" == "i386"
	lib /MACHINE:i386 /out:gc.lib $(OBJS)
!else
	lib /MACHINE:X64 /out:gc.lib $(OBJS)
!endif


gc_cpp.cpp: $(srcdir)\gc_cpp.cc
	copy $? $@

=== src/bdwgc/CMakeLists.txt ===
#
# Copyright (c) 1994 by Xerox Corporation.  All rights reserved.
# Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
# Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
# Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
##
# THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
# OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
##
# Permission is hereby granted to use or copy this program
# for any purpose,  provided the above notices are retained on all copies.
# Permission to modify the code and to distribute modified code is granted,
# provided the above notices are retained, and a notice that the code was
# modified is included with the above copyright notice.
##

#
#  get cmake and run:
#    cmake -G "Visual Studio 8 2005"
#  in the same dir as this file
#  this will generate gc.sln
#

SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

PROJECT(gc)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

ADD_DEFINITIONS("-D_CRT_SECURE_NO_DEPRECATE
                 -DALL_INTERIOR_POINTERS")

IF(APPLE)
    IF("${CMAKE_OSX_ARCHITECTURES}" STREQUAL "")
        SET(CMAKE_OSX_ARCHITECTURES "ppc;i386;x86_64" CACHE STRING "Build architectures for Mac OS X" FORCE)
    ENDIF()
ENDIF(APPLE)

#LIBATOMIC #TODO
#ADD_LIBRARY(atomic_ops STATIC )
#SET_TARGET_PROPERTIES(atomic_ops PROPERTIES COMPILE_FLAGS -DNO_DEBUGGING)


#LIBGC

INCLUDE_DIRECTORIES(include)
INCLUDE_DIRECTORIES(libatomic_ops/src)

SET(SRC alloc.c reclaim.c allchblk.c misc.c mach_dep.c os_dep.c
        mark_rts.c headers.c mark.c obj_map.c blacklst.c finalize.c
        new_hblk.c dbg_mlc.c malloc.c stubborn.c dyn_load.c
        typd_mlc.c ptr_chck.c gc_cpp.cc mallocx.c checksums.c
        thread_local_alloc.c)
SET(LIBS)
OPTION(enable_threads "TODO" NO)
IF(enable_threads)
        FIND_PACKAGE(Threads REQUIRED)
        MESSAGE("Thread Model: ${CMAKE_THREAD_LIBS_INIT}" )
        INCLUDE_DIRECTORIES(${Threads_INCLUDE_DIR})
        SET(LIBS ${LIBS} ${Threads_LIBRARIES})
ENDIF(enable_threads)

OPTION(enable_parallel_mark "Parallelize marking and free list construction" NO)

#IF(Threads_FOUND)
#       ADD_DEFINITIONS("")
#ELSE
#       MESSAGE("Parallel mark requires enable_threads ON" )
#ENDIF(Threads_FOUND)

IF(enable_parallel_mark)
ENDIF(enable_parallel_mark)

OPTION(enable_cplusplus "install C++ support" NO)

SET(_HOST ${CMAKE_HOST_SYSTEM_PROCESSOR}--${CMAKE_SYSTEM}) #FIXME missing the vendor field.Use lowercase

STRING(TOLOWER ${_HOST} HOST)
MESSAGE("HOST = ${HOST}")

#Thread Detection. Relying on cmake for lib an includes.
#TODO check cmake detection
IF(CMAKE_USE_PTHREADS_INIT)
        SET(SRC ${SRC} pthread_start.c pthread_support.c pthread_stop_world.c)
        IF( "HOST" MATCHES x86-.*-linux.*|ia64-.*-linux.*|i586-.*-linux.*|i686-.*-linux.*|x86_64-.*-linux.*|alpha-.*-linux.*|sparc.*-.*-linux.*)
                ADD_DEFINITIONS("-DGC_LINUX_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
                IF (${enable_parallel_mark})
                        ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF()
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                MESSAGE("Explicit GC_INIT() calls may be required.")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-linux.*)
                ADD_DEFINITIONS("-DGC_LINUX_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-aix.*)
                ADD_DEFINITIONS("-DGC_AIX_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-hpux11.*)
                MESSAGE("Only HP/UX 11 POSIX threads are supported.")
                ADD_DEFINITIONS("-DGC_HPUX_THREADS")
                ADD_DEFINITIONS("-D_POSIX_C_SOURCE=199506L") #TODO test -DVAR=value. Alternative is COMPILE_DEFINITIONS property
                IF (${enable_parallel_mark})
                        ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF()
                MESSAGE("Explicit GC_INIT() calls may be required.")
                ADD_DEFINITIONS("-D_REENTRANT") #TODO
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-hpux10.*)
                MESSAGE("Only HP/UX 11 POSIX threads are supported.")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-openbsd.*)
                ADD_DEFINITIONS("-DGC_OPENBSD_THREADS")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-freebsd.*)
                MESSAGE("FreeBSD does not yet fully support threads with Boehm GC.")
                ADD_DEFINITIONS("-DGC_FREEBSD_THREADS")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-kfreebsd.*-gnu)
                ADD_DEFINITIONS("-DGC_FREEBSD_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
                IF (${enable_parallel_mark})
                        ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF()
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                ADD_DEFINITIONS("-DUSE_COMPILER_TLS")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-gnu.*)
                ADD_DEFINITIONS("-DGC_GNU_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-netbsd.*)
                MESSAGE("Only on NetBSD 2.0 or later.")
                ADD_DEFINITIONS("-DGC_NETBSD_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
                ADD_DEFINITIONS("-D_PTHREADS")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-solaris.*)
                ADD_DEFINITIONS("-DGC_SOLARIS_THREADS")
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
#TODO
#       if test "$GCC" != yes; then
#          CFLAGS="$CFLAGS -O"
#          need_atomic_ops_asm=true
#        fi

        ENDIF()
        IF ( "HOST" MATCHES .*-.*-irix.*)
                ADD_DEFINITIONS("-DGC_IRIX_THREADS")
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-cygwin.*)
                ADD_DEFINITIONS("-DGC_THREADS")
                IF (${enable_parallel_mark})
                        ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF()
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")

#TODO
#       win32_threads=true
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-darwin.*)
                ADD_DEFINITIONS("-DGC_DARWIN_THREADS")
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                MESSAGE("Explicit GC_INIT() calls may be required.")
                SET(SRC ${SRC} darwin_stop_world.c)
                IF (${enable_parallel_mark})
                       ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF()
                #TODO
                #darwin_threads=true
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-osf*)
                ADD_DEFINITIONS("-DGC_OSF1_THREADS")
                IF (${enable_parallel_mark})
                        ADD_DEFINITIONS("-DPARALLEL_MARK")
                        ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                        MESSAGE("Explicit GC_INIT() calls may be required.")
                        # May want to enable it in other cases, too.
                        # Measurements haven't yet been done.
                ENDIF()
        ENDIF()
        IF ( "HOST" MATCHES .*-.*-linux.*)
                ADD_DEFINITIONS("-DGC_LINUX_THREADS")
                ADD_DEFINITIONS("-D_REENTRANT")
        ENDIF()
ENDIF(CMAKE_USE_PTHREADS_INIT)

IF(CMAKE_USE_WIN32_THREADS_INIT)
        ADD_DEFINITIONS("-DGC_THREADS")
        #win32_threads=true   TODO
        IF (${enable_parallel_mark})
                ADD_DEFINITIONS("-DPARALLEL_MARK")
                ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
        ENDIF()
        ADD_DEFINITIONS("-DEMPTY_GETENV_RESULTS") #TODO test
        SET(SRC ${SRC} win32_threads.c)
ENDIF(CMAKE_USE_WIN32_THREADS_INIT)

OPTION(enable_gcj_support "Support for gcj" NO)
IF(enable_gcj_support)
        ADD_DEFINITIONS("-DGC_GCJ_SUPPORT")
ENDIF(enable_gcj_support)


ADD_LIBRARY(          gc-lib   STATIC      ${SRC})
SET_TARGET_PROPERTIES(gc-lib   PROPERTIES
                      COMPILE_DEFINITIONS GC_NOT_DLL)
#TODO TARGET_LINK_LIBRARIES(...  ...  ${LIBS})

ADD_LIBRARY(          gcmt-lib STATIC      ${SRC})
SET_TARGET_PROPERTIES(gcmt-lib PROPERTIES
                      COMPILE_DEFINITIONS GC_NOT_DLL)

ADD_LIBRARY(          gcmt-dll  SHARED     ${SRC})

IF(WIN32)
  ADD_EXECUTABLE(cord cord/cordbscs.c cord/cordxtra.c
                 cord/tests/de.c cord/tests/de_win.c)
  SET_TARGET_PROPERTIES(cord PROPERTIES WIN32_EXECUTABLE TRUE)
  SET_TARGET_PROPERTIES(cord    PROPERTIES
                      COMPILE_DEFINITIONS GC_NOT_DLL)
  TARGET_LINK_LIBRARIES(cord gc-lib)
  TARGET_LINK_LIBRARIES(cord gdi32)
ENDIF(WIN32)

ADD_SUBDIRECTORY(tests)

=== examples/threads/import_win32/Makefile ===
all:
	@echo You must specify a compiler type: mingw or msvc

mingw: import-mingw.exe

import-mingw.exe: import.c
	gcc -g `ecl-config --cflags` import.c -o $@ `ecl-config --ldflags`

msvc: import-msvc.exe

import-msvc.exe: import.c
	ecl-cc --compile -c import.c
	ecl-cc --link -Fe$@ import.obj
	del /q import.obj

=== src/bdwgc/tests/CMakeLists.txt ===
#
# Copyright (c) 1994 by Xerox Corporation.  All rights reserved.
# Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
# Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
# Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
##
# THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
# OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
##
# Permission is hereby granted to use or copy this program
# for any purpose,  provided the above notices are retained on all copies.
# Permission to modify the code and to distribute modified code is granted,
# provided the above notices are retained, and a notice that the code was
# modified is included with the above copyright notice.
##

ADD_DEFINITIONS(-DGC_NOT_DLL)
ADD_EXECUTABLE(gctest WIN32 test.c)
TARGET_LINK_LIBRARIES(gctest gc-lib)

=== debian/changelog ===
ecl (16.1.2-4) unstable; urgency=medium

  * Team upload.
  * Fix watch file.
  * Update Vcs-* fields for move to salsa.
  * Move to section lisp (see also #895122).
  * Set Maintainer to debian-common-lisp@l.d.o.
  * Remove obsolete README.building.
  * Use new common-lisp.net Homepage.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 10 Apr 2018 14:07:35 +0200

ecl (16.1.2-3) unstable; urgency=medium

  * Add dependency on libffi-dev for ecl (Closes: #873091).
  * Use debhelper compat level 8.
  * Update Standards-Version to 4.1.0.

 -- Tobias Hansen <thansen@debian.org>  Sat, 02 Sep 2017 02:19:44 +0100

ecl (16.1.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Sun, 07 May 2017 15:38:58 +0100

ecl (16.1.2-1) experimental; urgency=medium

  * New upstream release.
  * Remove bignums-dont-collect-gmp-internal-memory.patch (applied upstream).

 -- Tobias Hansen <thansen@debian.org>  Wed, 29 Mar 2017 21:23:05 +0100

ecl (15.3.7+dfsg1-2) unstable; urgency=medium

  * Add bignums-dont-collect-gmp-internal-memory.patch. (Closes: #777473)
  * Add myself to Uploaders.
  * Bump Standards-Version to 3.9.8.
  * Update debian/watch.

 -- Tobias Hansen <thansen@debian.org>  Mon, 10 Oct 2016 17:34:53 +0100

=== debian/control ===
Source: ecl
Section: lisp
Priority: optional
Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
 Christoph Egger <christoph@debian.org>,
 Tobias Hansen <thansen@debian.org>
Build-Depends:
 debhelper (>= 10),
 dh-autoreconf,
 libgmp-dev,
 file,
 texinfo,
 libncurses5-dev,
 fakeroot,
 libgc-dev (>= 1:7.1),
 chrpath,
 install-info,
 libatomic-ops-dev,
 libffi-dev
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 4.1.0
Homepage: https://common-lisp.net/project/ecl/
Vcs-Git: https://salsa.debian.org/common-lisp-team/ecl/.git
Vcs-Browser: https://salsa.debian.org/common-lisp-team/ecl/

Package: ecl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libffi-dev, libgmp3-dev, libncurses5-dev, libgc-dev, libatomic-ops-dev, gcc
Provides: lisp-compiler
Suggests: slime, ecl-doc
Description: Embeddable Common-Lisp: has an interpreter and can compile to C
 ECL stands for Embeddable Common-Lisp. The ECL project is an
 effort to modernize Giuseppe Attardi's ECL environment to
 produce an implementation of the Common-Lisp language
 which complies to the ANSI X3J13 definition of the language.
 .
 The current ECL implementation features:
  * A bytecodes compiler and interpreter.
  * A translator to C.
  * A UFFI-compatible interface to C code.
  * A dynamic loader.
  * The possibility to build standalone executables and DLLs.
  * The Common-Lisp Object System (CLOS).
  * Conditions and restarts for handling errors.
  * Sockets as ordinary streams.
  * The GNU Multiprecision library for fast bignum operations.
  * A simple conservative mark & sweep garbage collector.
  * The Boehm-Weiser garbage collector.

=== debian/watch ===
version=4
opts="filenamemangle=s%ecl@ANY_VERSION@\.tgz%ecl-$1.tar.gz%" \
https://common-lisp.net/project/ecl/static/files/release/ecl@ANY_VERSION@(?:@ARCHIVE_EXT@|\.tgz)

## ecl 16.1.3+ds

=== msvc/Makefile ===
--- 
+++ 
@@ -10,8 +10,8 @@
 
 SHORT_SITE_NAME   =
 LONG_SITE_NAME    =
-ECL_VERSION       = 16.1.2
-ECL_VERSION_NUMBER= 161002
+ECL_VERSION       = 16.1.3
+ECL_VERSION_NUMBER= 160103
 ARCHITECTURE      = PENTIUM4
 SOFTWARE_TYPE     = NT
 SOFTWARE_VERSION  = 5.0
@@ -53,8 +53,6 @@
 ECL_ASDF    =
 # TCP support
 ECL_SOCKETS =
-# X Windows support
-# ECL_CLX     = 1
 # Regression Tests support
 ECL_RT      =
 # Defsystem support
@@ -180,10 +178,6 @@
 !ifdef ECL_SOCKETS
 ECL_MODULES  = $(ECL_MODULES) sockets
 ECL_FEATURES = (cons :wants-sockets $(ECL_FEATURES))
-!endif
-!ifdef ECL_CLX
-ECL_MODULES  = $(ECL_MODULES) clx
-ECL_FEATURES = (cons :wants-clx $(ECL_FEATURES))
 !endif
 !ifdef ECL_RT
 ECL_MODULES  = $(ECL_MODULES) rt
@@ -297,7 +291,6 @@
 	$(CP) $(srcdir)\cmp\load.lsp.in cmp\load.lsp
 cmp/cmpdefs.lsp: $(srcdir)/cmp/cmpdefs.lsp Makefile
 	c\cut "@ECL_CC@" "$(CC)" \
-	    "@CC_IS_CXX@" "nil" \
 	    "@CFLAGS@" "$(CFLAGS)" \
 	    "@CFLAGS_OPTIMIZE@" "$(CFLAGS_OPTIMIZE)" \
 	    "@ECL_CFLAGS@" "" \
@@ -363,11 +356,9 @@
 	$(CP) gmp.lib ..\eclgmp.lib
 	$(CP) gmp.h ..\ecl\gmp.h
 	cd ..
+
 sysfun.lsp:
 	$(CP) $(srcdir)\cmp\sysfun.lsp .\
-
-rt.lisp:
-	$(CP) $(srcdir)\..\contrib\rt\rt.lisp .\
 
 install:
 	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
@@ -393,3 +384,7 @@
 	for %i in ($(LIBRARIES) c\dpp.exe BUILD-STAMP help.doc ecl.lib) do $(CP) %i "$(libdir)"
 	for /f %i in ('type MODULES') do $(CP) %i "$(libdir)"
 	for %i in (ecl-static.lib) do IF EXIST %i $(CP) %i "$(libdir)"
+	IF NOT EXIST "$(docdir)" $(MKDIR) "$(docdir)"
+	for %i in (..\LICENSE ..\LGPL ..\README.md ..\CHANGELOG) do $(CP) %i "$(docdir)"
+!if "$(ECL_UNICODE)" != ""
+	IF NOT EXIST "$(libdir)\encodings" $(MKDIR) "$(libdir)\encodings"

=== msvc/c/Makefile ===
--- 
+++ 
@@ -5,10 +5,8 @@
 srcdir	= ..\..\src\c
 
 !if "$(ECL_WIN64)" != ""
-ECL_FFI_OBJ=
 ECL_FPE_CODE=fpe_none.c
 !else
-ECL_FFI_OBJ=ffi_x86.obj
 ECL_FPE_CODE=fpe_x86.c
 !endif
 
@@ -42,7 +40,7 @@
 #
 TRUE_CC = cl
 CC	= cl
-CFLAGS	= -c $(ECL_CFLAGS) -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/bdwgc/include  -I$(top_srcdir)/bdwgc/include/private
+CFLAGS	= -c $(ECL_CFLAGS) -DECL_BUILD -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/bdwgc/include  -I$(top_srcdir)/bdwgc/include/private
 
 SHELL	= /bin/sh
 RM	= del
@@ -66,7 +64,7 @@
 HFILES	= ..\ecl\config.h ..\ecl\atomic_ops.h $(HDIR)\ecl.h $(HDIR)\ecl-cmp.h\
 	$(HDIR)\object.h $(HDIR)\cs.h $(HDIR)\stacks.h\
 	$(HDIR)\external.h $(HDIR)\cons.h $(HDIR)\legacy.h\
-	$(HDIR)\number.h $(HDIR)\page.h $(HDIR)\unify.h\
+	$(HDIR)\number.h $(HDIR)\page.h \
 	$(HDIR)\internal.h $(HDIR)\ecl-inl.h $(HDIR)\bytecodes.h \
 	$(HDIR)\impl\math_dispatch.h
 
@@ -103,7 +101,7 @@
 	mapfun.obj multival.obj hash.obj format.obj pathname.obj\
 	structure.obj load.obj unixfsys.obj unixsys.obj \
 	ffi.obj alloc_2.obj tcp.obj $(THREADS_OBJ) serialize.obj \
-	$(ECL_FFI_OBJ) $(ECL_UCD_OBJ) $(ECL_SSE_OBJ)
+	$(ECL_UCD_OBJ) $(ECL_SSE_OBJ)
 
 all:	$(DPP) ..\eclmin.lib ..\cinit.obj
 
@@ -151,7 +149,8 @@
 	     do $(RM) %f
 	-for %f in (..\ecl\*.h) do $(RM) %f
 	-for %f in (cut.exe cut.obj dpp.exe dpp.obj) do $(RM) %f
-	-del /S /Q ..\ecl\atomic*
+	-del /S /Q ..\ecl\atomic_ops
+	-del /S /Q ..\ecl\impl
 
 # Build rules
 
@@ -164,8 +163,14 @@
 		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
 		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
 		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
-	        < ..\ecl\config.h.msvc6 > $@
-	xcopy /SYI $(top_srcdir)\h\* ..\ecl
+	        < ..\ecl\config.h.msvc6 > ..\ecl\config.h
+	cut.exe "@ECL_FPE_CODE@" "$(srcdir:\=/)/arch/$(ECL_FPE_CODE)" \
+		"@ECL_VERSION_NUMBER@" "$(ECL_VERSION_NUMBER)" \
+		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
+		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
+		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
+	        < ..\ecl\config-internal.h.msvc6 > ..\ecl\config-internal.h
+	xcopy /SYI $(top_srcdir)\h\*.h ..\ecl
 	-mkdir ..\ecl\atomic_ops
 	-mkdir ..\ecl\atomic_ops\sysdeps
 	xcopy /SYI $(top_srcdir)\bdwgc\libatomic_ops\src\atomic_ops.h ..\ecl

=== msvc/tests/Makefile ===
top_srcdir=..\..
ECLDIR=../package/
ECL=..\package\ecl.exe

all: show-fails

.PHONY: do-regressions cleanup clean-sources update

config.lsp: $(top_srcdir)\src\tests\config.lsp.in ..\c\cut.exe Makefile
	..\c\cut.exe "@builddir@" "./" \
	          "@top_srcdir@" "../.." \
	  < $(top_srcdir)\src\tests\config.lsp.in > config.lsp

output.ecl\regressions.log: config.lsp
	$(MAKE) do-regressions

do-regressions: regressions config.lsp
	set ECLDIR=$(ECLDIR)
	$(ECL) -norc -load config.lsp -eval "(ecl-tests::run-regressions-tests)" -eval "(ext:quit)"

show-fails: regressions.log
	type regressions.log

#
# Create directories
#
regressions.log: config.lsp
	$(MAKE) do-regressions

#
# Cleanup
#
clean:
	rm -rf output*

clean-sources:
	test -f config.lsp.in || rm -rf bugs
	rm -rf ansi-tests quicklisp

distclean: clean-sources clean
	rm -rf cache

update: clean-sources
	$(MAKE) regressions

=== src/doc/new-doc/Makefile ===
FILES= *.txi */*.txi figures/*

.PHONY: all pdf info html

all: pdf info html

pdf: new-doc.pdf
info: ecldoc.info
html: new-doc.html

new-doc.pdf: $(FILES)
	texi2pdf new-doc.txi

ecldoc.info: $(FILES)
	makeinfo new-doc.txi

new-doc.html: $(FILES)
	makeinfo --html --css-include=ecl.css --split=chapter new-doc.txi

clean:
	rm -rf *.{aux,cf,cfs,cp,cpp,cpps,cps,ex,exs,fn,fns,ft,fts,log,lsp,lsps,toc,tp,tps,vr,vrs,pdf,info,html}

=== debian/changelog ===
ecl (16.1.3+ds-4) unstable; urgency=medium

  * Team upload
  * parallel-ftbfs.patch: new patch, fixes parallel FTBFS (Closes: #949896)
  * Bump S-V to 4.5.0

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 01 Feb 2020 11:39:27 +0100

ecl (16.1.3+ds-3) unstable; urgency=medium

  * Team upload
  * Depend on libgmp-dev instead of now obsolete libgmp3-dev. Thanks to
    Patrice Duroux. (Closes: #934900)
  * libffi-3.3.patch: new patch, fixes FTBFS against libffi 3.3. Thanks to
    Matthias Klose. (Closes: #949288)
  * Bump to debhelper compat level 12
  * Bump S-V to 4.4.1

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 19 Jan 2020 13:52:34 +0100

ecl (16.1.3+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Wed, 16 Jan 2019 17:50:23 +0100

ecl (16.1.3+ds-1) experimental; urgency=medium

  * Team upload
  * New upstream release.
    Strip off embedded code copies of GMP, libffi and boehm GC, to make sure
    that we use the system versions, and to simplify copyright/license
    tracking.
  * no-embedded-copies.patch: new patch, fixes minor issues related to the
    removal of embedded copies.
  * Rewrite d/copyright using machine-readable format 1.0
  * Tarball is now automatically repackaged by uscan

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 30 Oct 2018 12:05:59 +0100

ecl (16.1.2-5) unstable; urgency=medium

  * Team upload
  * Fix typo in Vcs-Git.
  * Remove various obsolete files under debian/
  * format-security.patch: new patch, fixes FTBFS with -Werror=format-security
    (Closes: #714308)
  * Bump to debhelper compat level 11
  * Make the package build twice in a row
  * Remove obsolete Build-Conflicts against automake1.4
  * Add Rules-Requires-Root: no
  * Bump S-V to 4.2.1

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 28 Oct 2018 14:18:20 +0100

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	touch src/configure.in && \
	touch src/aclocal.m4 && \
	touch src/configure configure

	dh_auto_configure -- \
	   --enable-gmp=system \
	   --with-tcp \
	   --enable-threads=yes \
	   --enable-boehm=system  \
	   --enable-libatomic=system \
	   --disable-rpath \
	   --with-x

override_dh_autoreconf:
	dh_autoreconf autoreconf -- -f -i src/

#mostly require remote access
override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -f src/configure.in
